/* strp, Copyright(c) 1996, 1998
 * by Eddie Buckley <eddie@sjfn.nb.ca>
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  No representations are made about the suitability of this
 * software for any purpose.  It is provided "as is" without express or 
 * implied warranty.
 */

#include <stdlib.h>
#include <stdio.h>
#include "strp.h"

const	char	*arg_chars = "dhmuv";
const	char	*usage_chars = "[-d|-h|-m|-u|-v]";

int
to_unix(char curr, char last, char *buff, int posn)
{
	if(curr == CR)
		return(posn);
	else if( (curr == LF) && (last != CR) )
		*(buff+posn) = curr;
	else if( (last == CR) && (curr != LF) )
	    {
		*(buff+(posn++) ) = LF;
		*(buff+posn) = curr;
	    }
	else
		*(buff+posn) = curr;
	return(++posn);
}

int
to_dos(char curr, char last, char *buff, int posn)
{
	if(curr == CR)
		*(buff+posn) = curr;
	else if( (curr == LF) && (last != CR) )
	    {
		*(buff+(posn++) ) = CR;
		*(buff+posn) = curr;
	    }
	else if( (last == CR) && (curr != LF) )
	    {
		*(buff+(posn++) ) = LF;
		*(buff+posn) = curr;
	    }
	else
		*(buff+posn) = curr;
	return(++posn);
}

int
to_mac(char curr, char last, char *buff, int posn)
{
	if( (curr == LF) && (last == CR) )
		return(posn);
	else if(curr == CR)
		*(buff+posn) = curr;
	else if( (curr == LF) && (last != CR) )
		*(buff+posn) = CR;
	else
		*(buff+posn) = curr;
	return(++posn);
}

void
ver(void)
{
    printf("%s%s%s%s", "strp version ", VERSION, " Copyright(c) 1996, 1998 by ",
           "Eddie Buckley <eddie@sjfn.nb.ca>\n");
}

void
help(void)
{
    printf("Fix line breaks in FILE(s), or standard input to standard "
           "output.\n");
    printf("\n\t-d\tmake DOS format (CR-LF)\n");
    printf("\t-h\tshow this help and version number\n");
    printf("\t-m\tmake MAC/Amiga format (CR)\n");
    printf("\t-u\tmake UNIX format (LF)\n");
    printf("\t-v\tprint version number and exit\n");
    printf("\nIf more than one command line option is present only the first "
           "one is used.\n");
    printf("\nWith no FILE or when FILE is - read from standard input and "
           "write to standard\n output.\n\n");
}

char
arg_parse(char arg)
{

    switch(arg)
    {
        case 'h':
            ver();
            usage();
            help();
            exit(0);
            break;
        case 'd':
            func_p = to_dos;
            break;
        case 'm':
            func_p = to_mac;
            break;
        case 'u':
            func_p = to_unix;
            break;
        case 'v':
            ver();
            exit(0);
            break;
    }
    return '\0';
}

